--==================================
-- VERSION OF DATABASE	: 1.0.39
-- DATE			: 2004-02-11
--==================================

USE XSCommon
SET NOCOUNT ON
GO

--[Roles]
SET IDENTITY_INSERT tblRoles ON

IF NOT EXISTS(SELECT * FROM tblRoles WHERE RoleID= 1)
INSERT INTO tblRoles (RoleID, RoleName, IsAllowView, IsAllowEdit, IsAllowDelete, IsAllowInsert, IsAdmin)
VALUES(1,'Supervisor',1,1,1,1,1)
GO

IF NOT EXISTS(SELECT * FROM tblRoles WHERE RoleID= 2)
INSERT INTO tblRoles (RoleID, RoleName, IsAllowView, IsAllowEdit, IsAllowDelete, IsAllowInsert, IsAdmin)
VALUES(2,'Manager',1,1,1,1,0)
GO

IF NOT EXISTS(SELECT * FROM tblRoles WHERE RoleID= 3)
INSERT INTO tblRoles (RoleID, RoleName, IsAllowView, IsAllowEdit, IsAllowDelete, IsAllowInsert, IsAdmin)
VALUES(3,'Accountant',1,0,0,0,0)
GO

--[Users]
IF NOT EXISTS(SELECT * FROM tblUser WHERE UserName = 'trial')
INSERT INTO tblUser (RoleID, UserName, UserLogin, IsConfineRows)
VALUES(1,'trial','trial',0)
GO
IF NOT EXISTS(SELECT * FROM tblUser WHERE UserName = 'trial_paypunch')
INSERT INTO tblUser (RoleID, UserName, UserLogin, IsConfineRows)
VALUES(1,'trial_paypunch','trial_paypunch',0)
GO


--[Exception/shift types]

IF NOT EXISTS(SELECT * FROM tblExceptionType WHERE ExceptionTypeID = 1)
INSERT INTO tblExceptionType
VALUES(1,'working shift', NULL)
GO
IF NOT EXISTS(SELECT * FROM tblExceptionType WHERE ExceptionTypeID = 2)
INSERT INTO tblExceptionType	
VALUES(2,'paid vacation', NULL)
GO
IF NOT EXISTS(SELECT * FROM tblExceptionType WHERE ExceptionTypeID = 3)
INSERT INTO tblExceptionType
VALUES(3,'paid illness',NULL)
GO
IF NOT EXISTS(SELECT * FROM tblExceptionType WHERE ExceptionTypeID = 4)
INSERT INTO tblExceptionType	
VALUES(4,'day-for-day substitute',NULL)
GO

--[Variables]

--Minimum work time between two registrations (in min).
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 1) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,1,'Minimum work time between two registrations (in minutes)',5)
GO
--Maximum time for pre-term registration before shift begins (in minutes)
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 2) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,2,'Maximum time for pre-term registration before shift begins (in minutes)',60)
GO
--Maximum time for belated registration after shift completes (in minutes)
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 3) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,3,'Maximum time for belated registration after shift completes (in minutes)',60)
GO
--The number to correct calculated week number (in weeks). It can be negative, positive or zero
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 4) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,4,'The number to correct calculated week number (in weeks). It can be negative, positive or zero',0)
--The start day of week. 0 - use the day of week specified in your system settings for the first day of week, 1 - Sunday, 2 - Monday, 3 - Tuesday, 4 - Wednesday, 5 - Thursday, 6 - Friday, 7 - Saturday
GO
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 5) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,5,'The start day of week. 0 - use the day of week specified in your system settings for the first day of week, 1 - Sunday, 2 - Monday, 3 - Tuesday, 4 - Wednesday, 5 - Thursday, 6 - Friday, 7 - Saturday',0)
--The start week of year. 0 - use the date format contained in the regional settings for your computer, 1 - use the week in which January 1 occurs, 2 - use the first week that has at least four days in the new year, 3 - use the first full week of the year
GO
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 6) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,6,'The start week of year. 0 - use the date format contained in the regional settings for your computer, 1 - use the week in which January 1 occurs, 2 - use the first week that has at least four days in the new year, 3 - use the first full week of the year',0)
GO
--Regular (normal duration of day) work time (in minutes)
GO
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 7) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,7,'Regular duration of work week (work time in minutes)',2400)
GO
--Minimum work time including break (in minutes)
GO
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 8) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,8,'Minimum work time including break (in minutes)',240)
GO
--Minimum days since first registration for employee to have paid vacations paid (in days)
GO
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 9) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,9,'Minimum days since first registration for employee to have paid vacations paid (in days)',0)
GO
--0 - work day before paid vacation is not required for employee to have paid vacation paid, else required
GO
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 10) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,10,'0 - work day before paid vacation is not required for employee to have paid vacation paid, else required',0)
GO

--0 - work day after paid vacation is not required for employee to have paid vacation paid, else required
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 11) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,11,'0 - work day after paid vacation is not required for employee to have paid vacation paid, else required',0)
GO
-- The first day off within a workweek. 1 - Sunday, 2 - Monday, 3 - Tuesday, 4 - Wednesday, 5 - Thursday, 6 - Friday, 7 - Saturday
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 12) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,12,'The first day off within a workweek. 1 - Sunday, 2 - Monday, 3 - Tuesday, 4 - Wednesday, 5 - Thursday, 6 - Friday, 7 - Saturday',7)
GO
-- The number of days off per week (one after another)
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 13) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asInt)
	VALUES(NULL,NULL,13,'The number of days off per week (one after another)',2)
GO

-- The number of days off per week (one after another)
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 14) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asNvarchar)
	VALUES(NULL,NULL,14,'Factory destination folder','C:\PayPunch')
GO

-- The number of days off per week (one after another)
IF NOT EXISTS(SELECT VarTypeID FROM tblVariable 
	WHERE (VarTypeID = 15) AND (FactoryID IS NULL AND DepartmentID IS NULL))
	INSERT INTO tblVariable (FactoryID,DepartmentID,VarTypeID,[Description],asNvarchar)
	VALUES(NULL,NULL,15,'Advanced Export destination folder','C:\PayPunch')
GO

--[Messages]

IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50001)
INSERT INTO tblSystemMessage
VALUES(50001,'The operation cannot be executed because some required parameter values are missing or incorrect.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50002)
INSERT INTO tblSystemMessage
VALUES(50002,'The first value of period %s is more than the last one %s.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50003)
INSERT INTO tblSystemMessage
VALUES(50003,'Error occurred while executing the operation: %s.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50004)
INSERT INTO tblSystemMessage
VALUES(50004,'The operation cannot be executed because some parameter values are incorrect.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50005)
INSERT INTO tblSystemMessage
VALUES(50005,'The record(s) cannot be inserted into %s.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50006)
INSERT INTO tblSystemMessage
VALUES(50006,'The record(s) were not found in %s.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50007)
INSERT INTO tblSystemMessage
VALUES(50007,'The record(s) cannot be deleted from %s.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50008)
INSERT INTO tblSystemMessage
VALUES(50008,'The record(s) cannot be updated in %s.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50011)
INSERT INTO tblSystemMessage
VALUES(50011,'Authorization failed. Please check your name and password and try again.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50016)
INSERT INTO tblSystemMessage
VALUES(50016,'The user(s) were not found.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50017)
INSERT INTO tblSystemMessage
VALUES(50017,'The user was marked as deleted.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50018)
INSERT INTO tblSystemMessage
VALUES(50018,'You cannot create inactive shift/exception.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50019)
INSERT INTO tblSystemMessage
VALUES(50019,'You cannot create inactive employee.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50020)
INSERT INTO tblSystemMessage
VALUES(50020,'The shift/exception is assigned to active employee(s), so it cannot be made inactive.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50021)
INSERT INTO tblSystemMessage
VALUES(50021,'The specified shift is already assigned to some of the selected employees from the specified date.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50022)
INSERT INTO tblSystemMessage
VALUES(50022,'Another shift is already assigned to some of the selected employees from the specified date on the same day(s) of week.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50023)
INSERT INTO tblSystemMessage
VALUES(50023,'Another exception is already assigned to some of the selected employees for a cross period.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50024)
INSERT INTO tblSystemMessage
VALUES(50024,'Exception cannot be assigned for cross periods.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50025)
INSERT INTO tblSystemMessage
VALUES(50025,'Adjusted time must be unique.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50026)
INSERT INTO tblSystemMessage
VALUES(50026,'Break time of any shift cannot be greater than minimum work time including break for a factory.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50027)
INSERT INTO tblSystemMessage
VALUES(50027,'Minimum work time including break for a factory cannot be less than break time of any factory shift.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50028)
INSERT INTO tblSystemMessage
VALUES(50028,'The record(s) belong to the locked period.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50032)
INSERT INTO tblSystemMessage
VALUES(50032,'Minimum work time between two registrations violation.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50033)
INSERT INTO tblSystemMessage
VALUES(50033,'Some of the specified periods have been already assigned to this employee.')
GO
IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50034)
INSERT INTO tblSystemMessage
VALUES(50034,'The specified paid vacation has no periods and it cannot be assigned to employees.')
GO

IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50035)
INSERT INTO tblSystemMessage
VALUES(50035,'You have not got rights to view this information.')
GO

IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50036)
INSERT INTO tblSystemMessage
VALUES(50036,'User %s with  login %s can not be deleted in current session.')
GO

IF NOT EXISTS( SELECT MsgCode FROM tblSystemMessage WHERE MsgCode = 50037)
INSERT INTO tblSystemMessage
VALUES(50037,'User %s with  login %s already exist in database.')
GO

IF NOT EXISTS( SELECT * FROM tblVersion)
INSERT INTO tblVersion
VALUES('1','0','38',GETDATE())
GO
